#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <fcntl.h>

#include "../../dt2801.h"
#include "../../adc.h"

int main(int argc, char **argv) {

    int fd, stat;
    unsigned long* channels;
    caddr_t m;

    int i, clockticks;
    Dt2801_ADCP_t adp;

    clockticks = 10;

    adp.gain = 0;
    adp.startch = 0;
    adp.endch = 0;
    adp.conv = 100;


    fd = open("/dev/dt2801/adc", O_RDONLY);
    if (fd<0) {
        perror("open");
        exit(-1);
    }

    stat = ioctl(fd, DT2801_IOCTL_SETCLOCK, clockticks);
    if (stat != 0) {
        perror("setclock");
	close(fd);
        exit(-1);
    }

    stat = ioctl(fd, DT2801_IOCTL_ADC_SET_PARAMS, &adp);
    if (stat != 0) {
        perror("setparams");
	close(fd);
        exit(-1);
    }

    m = mmap( NULL, 100, PROT_READ, MAP_SHARED, fd, 0x0);
    if (m==-1) {
        perror("mmap");
        exit(-1);
    }

    getchar();

    /*
    stat = ioctl(fd, DT2801_IOCTL_ADC_BLOCKSTART, -1);
    if (stat != 0) {
	    perror("setclock");
	    close(fd);
	    exit(-1);
    }

    stat = ioctl(fd, DT2801_IOCTL_ADC_BLOCKSTOP, -1);
    if (stat != 0) {
	    perror("setclock");
	    close(fd);
	    exit(-1);
    }
    */





    channels = (unsigned long*) m;

    fprintf(stdout, "%p\n", channels);
    if (channels) {
        for (i=0; i<5; i++) {
            fprintf(stdout, "%u ", channels[i]);
        }
        fprintf(stdout, "\nOK.\n");
	fprintf(stdout, "%u\n", channels[80]);
    }

    getchar();

    munmap((caddr_t) channels, 100);
    close(fd);

    getchar();

    return 0;

}

